# -*- coding: utf-8 -*-

"""

    Baidu zhidao searcher

"""
import requests
import _thread

class AI:

    def __init__(self, question, answers,true_flag):
        self.question = question
        self.answers = answers
        self.stat = []
        self.summary = []
        self.count = 0
        self.timeout = 2
        self.true_flag = true_flag
        self.headers = {
            "Host": "www.baidu.com",
            "User-Agent": "Mozilla/5.0 (X11; Fedora; Linux x86_64; rv:57.0) Gecko/20100101 Firefox/57.0"
        }

    def ai_search(self):
        lans = len(self.answers)
        for i in range(lans): # 格式化答案并生成权重列表
            self.stat.append(0)
            self.summary.append(0)
        response = requests.get(url='http://www.baidu.com/s', params={'wd': self.question}, headers=self.headers, timeout=self.timeout)
        if not response.ok:
            return None
        resdata = response.text
        i = 0
        for ans in self.answers:
            self.summary[i]=resdata.count(ans)
            i=i+1
        self.print_answer1()
        try:
            for i in range(lans):
                _thread.start_new_thread(self.get_count_baidu, (i, "http://www.baidu.com/s?wd="+self.answers[i]))
            while True:
                if self.count == lans:
                    break
            for i in range(lans):
                _thread.start_new_thread(self.get_count_baidu, (i, "http://www.baidu.com/s?wd="+self.question+" "+self.answers[i]))
            while True:
                if self.count == lans*2:
                    break
            self.print_answer2()
        except:
            pass

    def get_count_baidu(self,sub,url):
        response = requests.get(url=url,headers=self.headers, timeout=self.timeout)
        if not response.ok:
            self.stat[sub] = 0.001
            self.count += 1
            return
        count = int(response.text.split("百度为您找到相关结果约")[1].split("个")[0].replace(",", ""))
        if self.stat[sub] == 0:
            self.stat[sub] = count + 0.001
        else:
            self.stat[sub] = count / self.stat[sub]
        self.count += 1

    def print_answer1(self):
        print("*" * 72)
        print("方法一")
        for i in range(len(self.answers)): # 输出每个答案的权重
            print("{} ({})".format(self.answers[i],str(self.summary[i])))
        if max(self.summary)== 0:
            print("方法一没有找到答案，参考方法二吧")
        else:
            if self.true_flag:
                maxindex = max(self.summary)
                if (self.summary[0] == maxindex) and (self.summary[1]==maxindex):
                    maxstr = self.answers[0]+','+self.answers[1]
                elif (self.summary[1] == maxindex) and (self.summary[2]==maxindex):
                    maxstr = self.answers[1]+','+self.answers[2]
                elif (self.summary[0] == maxindex) and (self.summary[2]==maxindex):
                    maxstr = self.answers[0]+','+self.answers[2]
                else:
                    maxstr =self.answers[self.summary.index(maxindex)]
                print("方法一肯定回答：{}".format(maxstr))
            else:
                minindex = min(self.summary)
                if (self.summary[0] == minindex) and (self.summary[1]==minindex):
                    minstr = self.answers[0]+','+self.answers[1]
                elif (self.summary[1] == minindex) and (self.summary[2]==minindex):
                    minstr = self.answers[1]+','+self.answers[2]
                elif (self.summary[0] == minindex) and (self.summary[2]==minindex):
                    minstr = self.answers[0]+','+self.answers[2]
                else:
                    minstr =self.answers[self.summary.index(minindex)]
                print("方法一否定回答：{}".format(minstr))

    def print_answer2(self):
        print("*" * 72)
        print("方法二")
        self.count = 0
        for i in range(len(self.answers)):
            self.count += self.stat[i] # 计算总数避免除数依然为零
        for i in range(len(self.answers)): # 输出每个答案的权重
            if self.answers[i] in self.question: # 如果问题中包含答案则调整权重
                self.stat[i] = int(self.stat[i] / 3)
            if self.count == 0:
                print("{} (0)".format(self.answers[i]))
            else:
                print("{} ({}%)".format(self.answers[i], int(self.stat[i] / self.count * 100)))
        if self.count == 0: # 输出建议回答
            print("方法二没有找到答案，蒙一个吧")
        else:
            if self.true_flag:
                print("方法二肯定回答：{}".format(self.answers[self.stat.index(max(self.stat))]))
            else:
                print("方法二否定回答：{}".format(self.answers[self.stat.index(min(self.stat))]))
        print("*" * 72)
