# -*- coding:utf-8 -*-
import time
import win32gui
from datetime import datetime
from argparse import ArgumentParser
from functools import partial
from config import api_key
from config import api_version
from config import app_id
from config import app_key
from config import app_secret
from config import data_directory
from config import image_compress_level
from config import prefer
from config import crop_areas
from getpic import analyze_current_screen_text
from getpic import save_screen
from ai import AI
from ocr import get_text_from_baiduocr as bai_get_text
from ocr import get_text_from_spaceocr as ocrspace_get_text
from selenium import webdriver
from selenium.webdriver.common.keys import Keys
from pyhooked import Hook, KeyboardEvent


if prefer[0] == "baidu":
    get_text_from_image = partial(bai_get_text,
                                  app_id=app_id,
                                  app_key=app_key,
                                  app_secret=app_secret,
                                  api_version=api_version,
                                  timeout=5)

elif prefer[0] == "ocrspace":
    get_test_from_image = partial(ocrspace_get_text, api_key=api_key)


def parse_args():
    parser = ArgumentParser(description="Million Hero Assistant")
    parser.add_argument(
        "-t", "--timeout",
        type=int,
        default=5,
        help="default http request timeout"
    )
    return parser.parse_args()


def parse_question_and_answer(text_list):
    question = ""
    n = len(text_list)
    for i in range(0,n-3):
        question += text_list[i]
    real_question = question.replace(".","").replace("、","")[1:]
    if (real_question[0] <= "2"):
        real_question = real_question[1:]
    return real_question, question, text_list[n-3:n]


def pre_process_question(keyword):
    """
    strip charactor and strip ?
    :param question:
    :return:
    """
    true_flag =True
    now = datetime.today()
    for char, repl in [("“", ""), ("”", ""), ("？", ""),("?", ""), ("《", ""), ("》", ""), ("我国", "中国"),("下列",""),("下面",""),("以下",""),
                       ("今天", "{0}年{1}月{2}日".format(now.year, now.month, now.day)),
                       ("今年", "{0}年".format(now.year)),
                       ("这个月", "{0}年{1}月".format(now.year, now.month))]:
        keyword = keyword.replace(char, repl)
    for char, repl in [("不是", "是"), ("不同", "相同"), ("不会", "会"), ("不用", "必须"), ("不宜", "适宜"), ("不包括", "包括"), ("不属于", "属于"),
                       ("不能", "能"),("不相等", "相等"),("不在", "在"),("不正确", "正确"),("不提供", "提供"), ("没有", "有"), ("未在", "在"),
                       ("未曾", "曾经"), ("是错", "是对")]:
        if char in keyword:
            keyword = keyword.replace(char, repl)
            true_flag = False
            break
    return keyword,true_flag

def pre_process_answers(keyword):
    """
    strip charactor and strip ?
    :param question:
    :return:
    """
    for i in range(len(keyword)):
        keyword [i] = keyword[i][2:]
    return keyword

def checkVm():
    print("""
    请选择打开模拟器: 
      1. 夜神模拟器
      2. 夜神模拟器1
    """)
    vm_type = input("输入模拟器序号: ")
    if vm_type == "1":
        vm_name = '夜神模拟器'
    elif vm_type == "2":
        vm_name = '夜神模拟器1'
    else:
        vm_name = '夜神模拟器'
    hld = win32gui.FindWindow(None, vm_name)
    if hld > 0:
        print('使用前用%s打开对应应用\n'%(vm_name))
    else:
        print('%s未打开,退出程序重新打开\n'%(vm_name))
    return hld

def checkHotkey():
    print("""
    热键选项: 
      1. F2  2. F3  3. F4  4. F5  5. F6
    """)
    key = input("输入热键序号: ")
    if key == "1":
        hot_key = 'F2'
    elif key == "2":
        hot_key = 'F3'
    elif key == "3":
        hot_key = 'F4'
    elif key == "4":
        hot_key = 'F5'
    elif key == "5":
        hot_key = 'F6'
    else:
        hot_key = 'F2'
    return hot_key

def handle_events(args):
    if isinstance(args, KeyboardEvent):
        if args.current_key == hot_key and args.event_type == 'key down':
            main()
        elif args.current_key == 'Q' and args.event_type == 'key down':
            hk.stop()
            print('退出啦~')

def main():
    print("当前选择答题游戏: {}".format(game_type))
    start = time.time()
    text_binary = analyze_current_screen_text(
        hld,
        directory=data_directory,
        compress_level=image_compress_level[0],
        crop_area = crop_areas[game_type]
    )
    keywords = get_text_from_image(
        image_data=text_binary,
    )
    if not keywords:
        print("text not recognize")
        return

    real_question, question, answers = parse_question_and_answer(keywords)
    print('-' * 72)
    print(real_question)
    search_question,true_flag = pre_process_question(real_question)
    elem = browser.find_element_by_id("kw")
    elem.clear()
    elem.send_keys(search_question)
    elem.send_keys(Keys.RETURN)
    if game_type.__contains__("YY"):
        answers = pre_process_answers(answers)
    AI(search_question,answers,true_flag).ai_search()
    end = time.time()
    print("use {0} 秒".format(end - start))

if __name__ == "__main__":
    args = parse_args()
    timeout = args.timeout
    hot_key  ="F4"
    hld = -1
    print("""
    请选择答题节目: 
      1. 百万英雄
      2. 冲顶大会
      3. YY直播
      4. 百万英雄模拟器
      5. YY直播模拟器
    """)
    game_index = input("输入节目序号: ")
    if game_index == "1":
        game_type = '百万英雄'
    elif game_index == "2":
        game_type = '冲顶大会'
    elif game_index == "3":
        game_type = 'YY直播'
    elif game_index == "4":
        game_type = '百万英雄模拟器'
    elif game_index == "5":
        game_type = 'YY直播模拟器'
    else:
        game_type = '百万英雄'
    if game_type.__contains__("模拟器"):
        hld = checkVm()
    hot_key = checkHotkey()
    if not hld == 0:
        print('题目出现的时候按%s，我就自动帮你去搜啦~\n'%(hot_key))
        browser = webdriver.Chrome()
        browser.get("http://www.baidu.com")
        hk = Hook()
        hk.handler = handle_events
        hk.hook()
        # while True:
        #     enter = input("按Enter键开始，按ESC键退出...")
        #     if enter == chr(27):
        #         break
        #     try:
        #         main()
        #     except Exception as e:
        #         print(str(e))